function YY = calibration_solver(x,utarget,qtarget,rhotottarget,rrRateP,etaP,betaP,meanziP,stdziP,alphaP,feregrateP,firmexotarget,NbarP,deltaktarget,fetechtarget,exoseptarget,shapeP,exponenpfP,piP,vcrate,markuptarget,omegaG)


w_SS                 = x(1);
N_SS                 = x(2);
hpP                  = x(3);
c_SS                 = x(4);
fcP                  = x(5);



deltak_SS            = deltaktarget;
q_SS                 = qtarget;
deltafP              = firmexotarget*rhotottarget/(1 + firmexotarget*rhotottarget);
lambdaP              = exoseptarget*(1-deltafP)*rhotottarget;                  
z_SS                 = 1;
tauW_SS              = 0.20;
tauK_SS              = 0.10;
markup_SS            = markuptarget;
u_SS                 = utarget;
rho_SS               = 1 - 1/((1-lambdaP)*(1-deltafP)*(1 + rhotottarget));
Ne_SS                = (deltafP/(1-deltafP))*N_SS;
sigmaMuP             = 1/(N_SS*(markup_SS - 1));
rpD_SS               = exp(-0.5*(NbarP-N_SS)/(sigmaMuP*NbarP*N_SS));
mc_SS                = rpD_SS/markup_SS;
ubP                  = rrRateP*w_SS/rpD_SS; 
vcP                  = vcrate*w_SS*q_SS;
zc_SS                = icdf('lognormal', rho_SS , meanziP , stdziP);
zavInt_SS            = (-1/2*piP^(1/2)*exp(1/2*(2*meanziP+stdziP^2*shapeP)*shapeP/(1-2*alphaP+alphaP^2))*(erf(1/2*2^(1/2)/stdziP*(-log(zc_SS)+log(zc_SS)*alphaP+stdziP^2*shapeP+meanziP-meanziP*alphaP)/(-1+alphaP))-erf(1/2*2^(1/2)*(-10000000000+10000000000*alphaP+stdziP^2*shapeP+meanziP-meanziP*alphaP)/stdziP/(-1+alphaP)))*exp(-shapeP*meanziP*alphaP/(-1+alphaP)^2)/piP^(1/2))/(1-rho_SS);
zav_SS               = zavInt_SS^(1/exponenpfP);
l_SS                 = 1 - u_SS;
m_SS                 = rhotottarget*l_SS;
v_SS                 = m_SS/q_SS;
s_SS                 = m_SS/u_SS;
% k_SS                 = ((1/betaP - (1 - deltak_SS))/(alphaP*mc_SS*z_SS*(zav_SS^shapeP)*(l_SS^(1-alphaP))))^(1/(alphaP-1));
k_SS                 =(((1/betaP - (1 - deltak_SS))*(1/(1 - tauK_SS)))/(alphaP*mc_SS*z_SS*(zav_SS^shapeP)*(l_SS^(1-alphaP))))^(1/(alphaP-1));
yn_SS                = z_SS*(zav_SS^shapeP)*(k_SS^alphaP)*(l_SS^(1-alphaP));
mpl_SS               = (1 - alphaP)*mc_SS*yn_SS/l_SS;
mplzc_SS             = mpl_SS*((zc_SS/zav_SS)^exponenpfP);
wzc_SS               = w_SS - etaP*(mpl_SS - mplzc_SS); 
% phi_SS               = mpl_SS + vcP/q_SS - (etaP*(mpl_SS + vcP*(s_SS/q_SS)) + (1-etaP)*(ubP + hpP) + (etaP*(1 - (1-lambdaP)*(1-deltafP)*(1-s_SS)*betaP)*fcP));
phi_SS               = mpl_SS + vcP/q_SS - w_SS;
lfirm_SS             = l_SS/N_SS;
vfirm_SS             = (v_SS - Ne_SS*lfirm_SS/q_SS)/(N_SS + Ne_SS);
mpk_SS               = alphaP*mc_SS*yn_SS/k_SS; 
kfirm_SS             = k_SS/N_SS;
yfirm_SS             = yn_SS/N_SS;
y_SS                 = rpD_SS*yfirm_SS*N_SS;
cm_SS                = c_SS - hpP*(1-l_SS);
ik_SS                = deltak_SS*k_SS;
fetechP              = fetechtarget*yn_SS;
fr_SS                = feregrateP*yn_SS;
feP                  = fetechP + fr_SS;
d_SS                 = rpD_SS*yfirm_SS - mpk_SS*kfirm_SS - vcP*vfirm_SS - rho_SS*lfirm_SS*fcP/(1-rho_SS)  - lfirm_SS*w_SS;
e_SS                 = feP+ vcP*(lfirm_SS/q_SS + vfirm_SS);
firing_SS            = etaP*(1 - (1-lambdaP)*(1-deltafP)*(1-s_SS)*betaP)*fcP;

rk_SS                = mpk_SS;
gdpIncome_SS         = w_SS*l_SS + rk_SS*k_SS + N_SS*d_SS;
r_SS                 = (1 - betaP)/betaP;
gc_SS                 = omegaG*gdpIncome_SS;

YY         =  [ - w_SS       + etaP*(mpl_SS + vcP*(s_SS/q_SS)) + (1-etaP)*(ubP + hpP)*(1/(1-tauW_SS)) + firing_SS;
                - e_SS       + (((1-deltafP)*betaP)/(1 - (1-deltafP)*betaP))*d_SS;
                - vcP/q_SS   + betaP*(1-lambdaP)*(1-deltafP)*( (1 - rho_SS)*phi_SS - rho_SS*fcP);  
                - y_SS       + cm_SS + Ne_SS*feP + ik_SS + vcP*v_SS + rho_SS*l_SS*fcP/(1-rho_SS) + gc_SS;
                - vcP        + q_SS*( - mpl_SS*((zc_SS/zav_SS)^exponenpfP) + wzc_SS - fcP);];

            % - y_SS       + cm_SS + Ne_SS*feP + ik_SS + vcP*v_SS + rho_SS*l_SS*fcP/(1-rho_SS);            
% - w_SS       + etaP*(mpl_SS + vcP*(s_SS/q_SS)) + (1-etaP)*(ubP + hpP) + firing_SS;
