// Endogenous Variables
var 
c                 // total consumption
l                 // aggregate employment
v                 // aggregate vacancies
w                 // wage
k                 // aggregate capital
ik                // investment in physical capital
zc                // job-productivity cutoff
q                 // probability of filling a vacancy
m                 // matches
s                 // job-finding probability
u                 // unemployment rate
zav               // average job productivity
rho               // endogenous separation rate
mpl               // marginal product of labor
mpk               // marginal product of capital
phi               // value of a match to the firm
surplusF          // firm surplus
surplusW          // worker surplus
oo                // value of unemployment
wzc               // wage marginal worker
y                 // aggregate output
rk                // real rate for capital
mc                // marginal cost
multR             // investment lagrange multiplier
adjI              // investment adjustment cost  
e                 // firm value
d                 // per-period firm profit
N                 // number of producers
Ne                // number of new entrants
rpD               // relative price 
elasticity        // elasticity of substitution
markup            // markup
yfirm             // firm output
yn                // firm production funtion
vfirm             // firm vacancies
lfirm             // firm employment
kfirm             // firm capital
Util              // household's utility
Welf              // household's welfare
uc                // marginal utility of consumption
zavInt            // integral to compute average job productivity
mplzc             // marginal product of marginal worker
seprate           // separation rate
cm                // market consumption
ie                // investment in new products 
z                 // aggregate productivity
gdpIncome         // GDP Income
gdpIncomedata     // GDP Income data-consistent
cmdata            // market consumption data-consistent
ikdata            // investment in physical capital data-consistent
iedata            // investment in new products data-consistent 
wdata             // wage data-consistent
cdata             // total consumption data-consistent
ub                // unemployment benefit
fc                // firing cost
fr                // sunk entry cost regulation
gc
//gdata
tauW
tauK
thetaP
ooption
totsepfirm
totsepagg
JD
JC
netJC
vi
ve
r
kq
endosepAG
edata
ddata
wzcdata
wageinc
capinc
divinc
PRspend
totinc
totspend
re
mrs
T
;


// Innovations
varexo epsZ epsG epsW epsK; 

parameters   gammaP betaP rhozP stdzP lambdaP etaP epsP meanziP stdziP alphaP piP adjIP deltafP  NbarP sigmaMuP chiP vcP fetechP deltakP shapeP exponenpfP fetechtarget hpP rhoG rhoW rhoK stdgP stdwP stdkP tauK_SS tauW_SS,
           c_SS l_SS v_SS w_SS  k_SS ik_SS zc_SS q_SS m_SS s_SS u_SS zav_SS rho_SS mpl_SS mpk_SS phi_SS surplusF_SS surplusW_SS oo_SS wzc_SS y_SS rk_SS mc_SS multR_SS adjI_SS
           e_SS d_SS N_SS Ne_SS rpD_SS elasticity_SS markup_SS yfirm_SS yn_SS vfirm_SS lfirm_SS kfirm_SS uc_SS  zavInt_SS
           surplusFzc_SS surplusWzc_SS phizc_SS mplzc_SS cm_SS ub_SS fc_SS fr_SS z_SS gdpIncome_SS gc_SS gdata_SS tauW_SS D_SS tauK_SS thetaP_SS ooption_SS firing_SS 
           endosepfirm_SS exosepfirm_SS endosepAG_SS exosepAG_SS newhiresfirm_SS newhiresAG_SS totsepfirm_SS totsepagg_SS JD_SS JC_SS netJC_SS vi_SS ve_SS r_SS endosepAG_SS
           wageinc_SS capinc_SS divinc_SS PRspend_SS totinc_SS totspend_SS  re_SS mrs_SS T_SS kq_SS
           c_SSinit l_SSinit  k_SSinit q_SSinit  N_SSinit Ne_SSinit z_SSinit  ik_SSinit c_SSinit lfirm_SSinit vfirm_SSinit  fr_SSinit ub_SSinit fc_SSinit gc_SSinit;


set_parameters_from_file('steady',M_.param_names);
set_parameters_from_file('steadyInitial',M_.param_names);
set_parameters_from_file('calibration',M_.param_names);


model;

// %---Utility Function
Util              = log(exp(c));

Welf              = Util + betaP*Welf(1);


//% Labor Market Block
- exp(lfirm)      + (1-lambdaP)*(1-exp(rho))*exp(lfirm(-1)) + (1-lambdaP)*(1-exp(rho))*exp(q(-1))*exp(vfirm(-1));

- vcP/exp(q)      + (1-lambdaP)*(1-deltafP)*(betaP*exp(uc(1))/exp(uc))*((1 - exp(rho(1)))*exp(phi(1)) - exp(rho(1))*fc);  

- exp(mplzc)      + exp(wzc) - vcP/exp(q)  - fc;

//- exp(surplusF)   + ( (1 - etaP)/etaP )*exp(surplusW);

//- exp(surplusF) + ( (1 - etaP)/etaP )*exp(surplusW)*(1/(1-exp(tauW)));

//- exp(surplusF) + ( (1 - etaP)/etaP )*exp(surplusW)*(1/(1-exp(tauW_SS)));

- exp(surplusF) + ( (1 - etaP)/etaP )*exp(surplusW)*(1/(1-tauW));

- exp(wzc)        + exp(w) - etaP*(exp(mpl) - exp(mplzc)); 

- exp(yn)         + exp(z)*(exp(zav)^shapeP)*(exp(k(-1))^alphaP)*(exp(l)^(1-alphaP));

- exp(kq)         + vcP/exp(q);

//%% Entry Block
- exp(d)          + exp(rpD)*exp(yfirm) - exp(w)*exp(lfirm) - vcP*exp(vfirm) - exp(mpk)*exp(kfirm) - exp(rho)*exp(lfirm)*fc/(1-exp(rho));  
 
- exp(e)          + (fetechP + fr) + vcP*(exp(lfirm)/exp(q) + exp(vfirm)) ;

- exp(yfirm)      + exp(yn)/exp(N);

- exp(rpD)        + exp(markup)*exp(mc);

- exp(e)          + (1 - deltafP)*betaP*(exp(uc(1))/exp(uc))*(exp(e(+1)) + exp(d(+1)));

- exp(N)          + (1 - deltafP )*(exp(N(-1)) + exp(Ne(-1)));

- 1               + exp(rpD)*((exp(.5*(NbarP - exp(N))/(sigmaMuP*NbarP*exp(N))))) ;

- exp(markup)     + exp(elasticity)/(exp(elasticity) - 1);

- exp(elasticity) + ((1 + sigmaMuP*exp(N)));

- exp(yfirm)      + (1/exp(rpD))*exp(y)/exp(N);

//- exp(y)          + exp(cm) + exp(ik) + vcP*exp(v) + exp(Ne)*(fetechP + fr) + exp(rho)*exp(lfirm)*exp(N)*fc/(1-exp(rho));  

- exp(y)          + exp(cm) + exp(ik) + vcP*exp(v) + exp(Ne)*(fetechP + fr) + exp(rho)*exp(lfirm)*exp(N)*fc/(1-exp(rho)) + exp(gc); 

//%% Capital Accumulation 

- exp(k)          + (1 - deltakP)*exp(k(-1))   +  exp(ik)*(1 - (adjIP/2)*(adjI^2));

//- exp(multR)      + (betaP*exp(uc(1))/exp(uc))*(exp(rk(1)) + (1 - deltakP)*exp(multR(1)));

//- exp(multR)      + (betaP*exp(uc(1))/exp(uc))*(exp(rk(1))*(1 - exp(tauK)) + (1 - deltakP)*exp(multR(1)));

- exp(multR)      + (betaP*exp(uc(1))/exp(uc))*(exp(rk(1))*(1 - tauK) + (1 - deltakP)*exp(multR(1)));

- 1               + exp(multR)*((1 - (adjIP/2)*(adjI^2))  -  adjIP*adjI*(exp(ik)/exp(ik(-1))))  + adjIP*(betaP*exp(uc(1))/exp(uc))*exp(multR(1))*(adjI(1)*((exp(ik(1))/exp(ik))^2));

- adjI            + exp(ik)/exp(ik(-1)) - 1;


// %% New: Euler equation for bonds

- exp(uc)         + betaP*(exp(uc(1))*(1 + exp(r)));

//% Definitions (required to solve the model)

- exp(phi)        + exp(mpl) - exp(w) + (1-lambdaP)*(1-deltafP)*(betaP*exp(uc(1))/exp(uc))*( (1-exp(rho(1)))*exp(phi(1)) - exp(rho(1))*fc(1) );  

//- exp(surplusW)   + exp(w) - exp(oo) + (1-lambdaP)*(1-deltafP)*(betaP*exp(uc(1))/exp(uc))*(1-exp(rho(1)))*exp(surplusW(1)); 

//- exp(surplusW)   + (1-exp(tauW))*exp(w) - exp(oo) + (1-lambdaP)*(1-deltafP)*(betaP*exp(uc(1))/exp(uc))*(1-exp(rho(1)))*exp(surplusW(1)); 

//- exp(surplusW)   + (1-exp(tauW_SS))*exp(w) - exp(oo) + (1-lambdaP)*(1-deltafP)*(betaP*exp(uc(1))/exp(uc))*(1-exp(rho(1)))*exp(surplusW(1));

- exp(surplusW)   + (1-tauW)*exp(w) - exp(oo) + (1-lambdaP)*(1-deltafP)*(betaP*exp(uc(1))/exp(uc))*(1-exp(rho(1)))*exp(surplusW(1));

- exp(oo)         + hpP + ub  + (1-lambdaP)*(1-deltafP)*betaP*(exp(uc(1))/exp(uc))*(exp(s))*(1-exp(rho(1)))*exp(surplusW(1));

- exp(v)          + (exp(N) + exp(Ne))*exp(vfirm) + exp(Ne)*exp(lfirm)/exp(q) ; 

- exp(lfirm)      + exp(l)/exp(N); 

- exp(kfirm)      + exp(k(-1))/exp(N); 

- exp(m)          + (chiP*(exp(v)^(1-epsP))*(exp(u)^(epsP)));

- exp(u)          + 1 - exp(l);

- exp(s)          + exp(m)/exp(u);

- exp(q)          + exp(m)/exp(v);

- exp(zavInt)     + (-1/2*piP^(1/2)*exp(1/2*(2*meanziP+stdziP^2*shapeP)*shapeP/(1-2*alphaP+alphaP^2))*(erf(1/2*2^(1/2)/stdziP*(-log(exp(zc))+log(exp(zc))*alphaP+stdziP^2*shapeP+meanziP-meanziP*alphaP)/(-1+alphaP))-erf(1/2*2^(1/2)*(-10000000000+10000000000*alphaP+stdziP^2*shapeP+meanziP-meanziP*alphaP)/stdziP/(-1+alphaP)))*exp(-shapeP*meanziP*alphaP/(-1+alphaP)^2)/piP^(1/2))/(1-exp(rho));

- exp(zav)        + exp(zavInt)^((1 - alphaP)/shapeP);

- exp(rho)        + ((0.5 + 0.5 * erf((log(exp(zc)))/(stdziP*sqrt(2)))));

- exp(mpl)        + (1-alphaP)*exp(mc)*exp(yn)/exp(l);

- exp(mplzc)      + exp(mpl)*(exp(zc)/exp(zav))^exponenpfP;

- exp(mpk)        + alphaP*exp(mc)*exp(yn)/exp(k(-1));

- exp(surplusF)   + exp(phi) + fc;
  
- exp(rk)         + exp(mpk);

- exp(cm)         + exp(c) - hpP*(1-exp(l));

- exp(uc)         + exp(c)^-gammaP;

- exp(mrs)        + exp(uc(1))/exp(uc);


//% Exogenous Processes
- z               + rhozP*z(-1) - epsZ; 

- ub              + ub_SS;

- fc              + fc_SS;

- fr              + fr_SS;

- gc              + (1 - rhoG)*log(gc_SS) + rhoG*gc(-1) + epsG;

//- tauW            + (1 - rhoW)*log(tauW_SS) + rhoW*tauW(-1) + epsW; 

- tauW            + tauW_SS + epsW;         

//- tauK            + (1 - rhoK)*log(tauK_SS) + rhoK*tauK(-1) + epsK;

- tauK            + tauK_SS + epsK;


//% Additional variables (not needed to solve the model)
- exp(seprate)         + lambdaP + exp(rho)*(1-lambdaP)+ deltafP*(1-lambdaP)*(1-exp(rho));//lambdaP + exp(rho)*(1-lambdaP)+ deltafP*(1-lambdaP)*(1-exp(rho));

- exp(gdpIncome)  + exp(w)*exp(l) + exp(rk)*exp(k(-1)) + exp(N)*exp(d);

- exp(ie)         + exp(Ne)*(fetechP + fr);

- exp(gdpIncomedata) + exp(gdpIncome)/exp(rpD);

- exp(cmdata)     + exp(cm)/exp(rpD);

- exp(ikdata)     + exp(ik)/exp(rpD);

- exp(wdata)      + exp(w)/exp(rpD);

- exp(cdata)      + exp(c)/exp(rpD);

- exp(iedata)     + exp(ie)/exp(rpD);

//Additional variables

- exp(thetaP)     + exp(v)/exp(u);

- exp(ooption)    + hpP + ub + (etaP/(1 - etaP))*(vcP*exp(thetaP) + exp(s)*((1-lambdaP)*(1-deltafP)*betaP*exp(uc(1))/exp(uc)*fc));

- exp(totsepfirm) + lambdaP + (1-lambdaP)*exp(rho);

- exp(totsepagg)  + 1 - ((1 - exp(totsepfirm))*(1 - deltafP)); 

- exp(endosepAG)  + (1 - lambdaP)*exp(rho)*exp(l);

- exp(JD)         + exp(totsepagg)*(exp(l)) - lambdaP*exp(l)*exp(q);
 
- exp(JC)         + exp(v)*exp(q) - lambdaP*exp(l)*exp(q);

- exp(netJC)      + exp(JC) - exp(JD);

- exp(ve)         + (exp(lfirm)/exp(q) + exp(vfirm))*exp(Ne);

- exp(vi)         + exp(v) - exp(ve);

- exp(edata)      + exp(e)/exp(rpD);
 
- exp(ddata)      + exp(d)/exp(rpD);   

- exp(wzcdata)    + exp(wzc)/exp(rpD);

//- exp(wageinc)    + exp(w)*exp(l);

//- exp(wageinc)    + (1 - exp(tauW))*exp(w)*exp(l);

- exp(wageinc)    + (1 - tauW)*exp(w)*exp(l);

//- exp(capinc)     + exp(rk)*exp(k);

//- exp(capinc)     + (1 - exp(tauK))*exp(rk)*exp(k);

- exp(capinc)     + (1 - tauK)*exp(rk)*exp(k);

- exp(divinc)     + (exp(d) + exp(e))*exp(N);

- exp(PRspend)    + (exp(N) + exp(Ne))*exp(e);

//- exp(totinc)     + exp(wageinc) + exp(capinc) + exp(divinc) + (exp(tauW)*exp(w)*exp(l) - exp(tauK)*exp(rk)*exp(k) - exp(gc));

- exp(totinc)     + exp(wageinc) + exp(capinc) + exp(divinc) + (tauW*exp(w)*exp(l) - tauK*exp(rk)*exp(k) - exp(gc));

- exp(totspend)   + exp(cm) + exp(PRspend) + exp(ik);

//- exp(re)         + (exp(edata(1)) + exp(ddata(1)))/exp(edata);

- exp(re)         + (exp(e(1)) + exp(d(1)))/exp(e);

//- exp(T)          + exp(gc) - exp(tauW)*exp(w)*exp(l) - exp(tauK)*exp(rk)*exp(k);

- exp(T)          + exp(gc) - tauW*exp(w)*exp(l) - tauK*exp(rk)*exp(k);

end;


initval;
ub                  = ub_SS;
fc                  = fc_SS;
fr                  = fr_SS;
z                   = log(z_SS);
c                   = log(c_SS); 
l                   = log(l_SS);
u                   = log(u_SS);
q                   = log(q_SS);
s                   = log(s_SS);
v                   = log(v_SS);
m                   = log(m_SS);
mc                  = log(mc_SS);
rho                 = log(rho_SS);
zavInt              = log(zavInt_SS);
zav                 = log(zav_SS);
zc                  = log(zc_SS);
surplusF            = log(surplusF_SS);
surplusW            = log(surplusW_SS);
oo                  = log(oo_SS);
phi                 = log(phi_SS);
ik                  = log(ik_SS);
rk                  = log(rk_SS);
mpk                 = log(mpk_SS);
mpl                 = log(mpl_SS);
y                   = log(y_SS);
k                   = log(k_SS);
adjI                = adjI_SS;
multR               = log(multR_SS);
e                   = log(e_SS);
d                   = log(d_SS);
N                   = log(N_SS);
Ne                  = log(Ne_SS);
rpD                 = log(rpD_SS);
elasticity          = log(elasticity_SS);
markup              = log(markup_SS);
yfirm               = log(yfirm_SS);
yn                  = log(yn_SS);
lfirm               = log(lfirm_SS);
kfirm               = log(kfirm_SS);
vfirm               = log(vfirm_SS);
Util                = log(c_SS) ;
Welf                = (1/(1-betaP))*Util;
uc                  = log((exp(c))^-gammaP);
w                   = log(w_SS);
mplzc               = log(exp(mpl)*(exp(zc)/exp(zav))^exponenpfP);
wzc                 = log(exp(w) - etaP*(exp(mpl) - exp(mplzc)));
seprate             = log(lambdaP + (rho_SS)*(1-lambdaP)+ deltafP*(1-lambdaP)*(1-rho_SS));
cm                  = log(cm_SS);
gdpIncome           = log(gdpIncome_SS);
cmdata              = log(exp(cm)/exp(rpD));
gdpIncomedata       = log(exp(gdpIncome)/exp(rpD));
ikdata              = log(exp(ik)/exp(rpD));
wdata               = log(exp(w)/exp(rpD));
cdata               = log(exp(c)/exp(rpD));
ie                  = log(exp(Ne)*(fetechP + fr));
iedata              = log(exp(ie)/exp(rpD));
gc                  = log(gc_SS);
//gdata               = log(gdata_SS);
//D                   = log(D_SS);
//tauW                = log(tauW_SS);
//tauK                = log(tauK_SS);
tauW                = tauW_SS;
tauK                = tauK_SS;
thetaP              = log(thetaP_SS);
ooption             = log(ooption_SS);
totsepfirm          = log(totsepfirm_SS);
totsepagg           = log(totsepagg_SS);
JD                  = log(JD_SS);
JC                  = log(JC_SS);
netJC               = log(netJC_SS);
ve                  = log(ve_SS);
vi                  = log(vi_SS);
r                   = log(r_SS);
kq                  = log(kq_SS);
endosepAG           = log(endosepAG_SS);
edata               = log(exp(e)/exp(rpD));
ddata               = log(exp(d)/exp(rpD));
wzcdata             = log(exp(wzc)/exp(rpD));
wageinc             = log(wageinc_SS);
capinc              = log(capinc_SS);
divinc              = log(divinc_SS);
PRspend             = log(PRspend_SS);
totinc              = log(totinc_SS);
totspend            = log(totspend_SS);
re                  = log(re_SS);
mrs                 = log(mrs_SS);
T                   = log(T_SS);
end;


resid(1);

if max(abs(resid))>1e-10
    display('RESIDUALS IN THE CYCLE_IRF.MOD FILE ARE NOT ZERO')
    keyboard
end


shocks;
//var epsZ; stderr stdzP;
var epsG; stderr stdgP;
//var epsW; stderr stdwP;
//var epsK; stderr stdkP; 
end;




stoch_simul(order=1,irf=20,nograph,noprint) cmdata u ikdata gdpIncome gdpIncomedata wdata N Ne iedata markup ub fr fc wdata s thetaP ooption m q zc v vfirm lfirm rho totsepfirm totsepagg endosepAG JD JC netJC d yfirm vi ve tauK tauW gc ub surplusW mpl mpk e oo r kq wzc mc surplusF surplusW zav phi wzcdata elasticity vfirm lfirm kfirm uc mplzc seprate rk wageinc capinc divinc PRspend totinc totspend z y re mrs multR mc rpD T; 

//stoch_simul(pruning,order=2,irf=20,hp_filter=1600,periods=500) cmdata u ikdata gdpIncomedata wdata N iedata markup ub fr fc wdata s thetaP ooption m q zc v vfirm lfirm rho totsepfirm totsepagg JD JC netJC d yfirm vi ve tauK tauW gc ub surplusW mpl oo r; 




/*
subplot(12,5,1);
plot((z_epsZ),'b','Linewidth',2);axis tight;grid on; title('Tech. shock');
subplot(12,5,2);
plot(100*(cmdata_epsZ),'b','Linewidth',2);axis tight;grid on; title('Consumption');
subplot(12,5,3);
plot(100*(u_epsZ*u_SS),'b','Linewidth',2);axis tight;grid on; title('Unemployment rate');
subplot(12,5,4);
plot(100*(ikdata_epsZ),'b','Linewidth',2);axis tight;grid on; title('Investment physical capital');
subplot(12,5,5);
plot(100*(gdpIncomedata_epsZ),'b','Linewidth',2);axis tight;grid on; title('GDP');
subplot(12,5,6);
plot(100*(wdata_epsZ),'b','Linewidth',2);grid on;axis tight, title('Wage');
subplot(12,5,7);
plot(100*(N_epsZ),'b','Linewidth',2);grid on;axis tight, title('Producers');
subplot(12,5,8);
plot(100*(iedata_epsZ),'b','Linewidth',2);axis tight;grid on; title('Investment new products');
subplot(12,5,9);
plot(100*(markup_epsZ),'b','Linewidth',2);axis tight;grid on; title('Markup');
subplot(12,5,10);
plot(100*(s_epsZ),'b','Linewidth',2);axis tight;grid on; title('Job-finding prob.');
subplot(12,5,11);
plot(100*(thetaP_epsZ),'b','Linewidth',2);axis tight;grid on; title('Labour mkt tight');
subplot(12,5,12);
plot(100*(ooption_epsZ),'b','Linewidth',2);axis tight;grid on; title('Outside option');
subplot(12,5,13);
plot(100*(surplusW_epsZ),'b','Linewidth',2);axis tight;grid on; title('surplusW');
subplot(12,5,14);
plot(100*(yfirm_epsZ),'b','Linewidth',2);axis tight;grid on; title('Firm output');
subplot(12,5,15);
plot(100*(d_epsZ),'b','Linewidth',2);axis tight;grid on; title('Profit');
subplot(12,5,16);
plot(100*(q_epsZ),'b','Linewidth',2);axis tight;grid on; title('Prob. fill vacancy');
subplot(12,5,17);
plot(100*(zc_epsZ),'b','Linewidth',2);axis tight;grid on; title('Prod. cut-off');
subplot(12,5,18);
plot(100*(vi_epsZ),'b','Linewidth',2);axis tight;grid on; title('V incumbents');
subplot(12,5,19);
plot(100*(ve_epsZ),'b','Linewidth',2);axis tight;grid on; title('V entrants');
subplot(12,5,20);
plot(100*(v_epsZ),'b','Linewidth',2);axis tight;grid on; title('Vacancies');
subplot(12,5,21);
plot(100*(rho_epsZ),'b','Linewidth',2);axis tight;grid on; title('Endo. separate');
subplot(12,5,22);
plot(100*(totsepagg_epsZ),'b','Linewidth',2);axis tight;grid on; title('totsep agg');
subplot(12,5,23);
plot(100*(endosepAG_epsZ),'b','Linewidth',2);axis tight;grid on; title('endosep agg');
subplot(12,5,24);
plot(100*(m_epsZ),'b','Linewidth',2);axis tight;grid on; title('m');
subplot(12,5,25);
plot(100*(kq_epsZ),'b','Linewidth',2);axis tight;grid on; title('fut. match val.');
subplot(12,5,26);
plot(100*(JC_epsZ),'b','Linewidth',2);axis tight;grid on; title('JC');
subplot(12,5,27);
plot(100*(JD_epsZ),'b','Linewidth',2);axis tight;grid on; title('JD');
subplot(12,5,28);
plot(100*(netJC_epsZ),'b','Linewidth',2);axis tight;grid on; title('netJC');
subplot(12,5,29);
plot(100*(r_epsZ),'b','Linewidth',2);axis tight;grid on; title('r');
subplot(12,5,30);
plot(100*(mpl_epsZ),'b','Linewidth',2);axis tight;grid on; title('mpl');
subplot(12,5,31);
plot(100*(mpk_epsZ),'b','Linewidth',2);axis tight;grid on; title('mpk');
subplot(12,5,32);
plot(100*(mc_epsZ),'b','Linewidth',2);axis tight;grid on; title('MC');
subplot(12,5,33);
plot(100*(zav_epsZ),'b','Linewidth',2);axis tight;grid on; title('z avg');
subplot(12,5,34);
plot(100*(surplusF_epsZ),'b','Linewidth',2);axis tight;grid on; title('surplusF');
subplot(12,5,35);
plot(100*(phi_epsZ),'b','Linewidth',2);axis tight;grid on; title('match val');
subplot(12,5,36);
plot(100*(wzcdata_epsZ),'b','Linewidth',2);axis tight;grid on; title('wzcdata');
subplot(12,5,37);
plot(100*(rpD_epsZ),'b','Linewidth',2);axis tight;grid on; title('rel. price');
subplot(12,5,38);
plot(100*(vfirm_epsZ),'b','Linewidth',2);axis tight;grid on; title('vfirm');
subplot(12,5,39);
plot(100*(lfirm_epsZ),'b','Linewidth',2);axis tight;grid on; title('lfirm');
subplot(12,5,40);
plot(100*(kfirm_epsZ),'b','Linewidth',2);axis tight;grid on; title('kfirm');
subplot(12,5,41);
plot(100*(uc_epsZ),'b','Linewidth',2);axis tight;grid on; title('uc');
subplot(12,5,42);
plot(100*(mplzc_epsZ),'b','Linewidth',2);axis tight;grid on; title('mplzc');
subplot(12,5,43);
plot(100*(seprate_epsZ),'b','Linewidth',2);axis tight;grid on; title('seprate');
subplot(12,5,44);
plot(100*(e_epsZ),'b','Linewidth',2);axis tight;grid on; title('e');
subplot(12,5,45);
plot(100*(wageinc_epsZ),'b','Linewidth',2);axis tight;grid on; title('wageinc');
subplot(12,5,46);
plot(100*(capinc_epsZ),'b','Linewidth',2);axis tight;grid on; title('capinc');
subplot(12,5,47);
plot(100*(divinc_epsZ),'b','Linewidth',2);axis tight;grid on; title('divinc');
subplot(12,5,48);
plot(100*(PRspend_epsZ),'b','Linewidth',2);axis tight;grid on; title('PRspend');
subplot(12,5,49);
plot(100*(totinc_epsZ),'b','Linewidth',2);axis tight;grid on; title('totinc');
subplot(12,5,50);
plot(100*(totspend_epsZ),'b','Linewidth',2);axis tight;grid on; title('totspend');
subplot(12,5,51);
plot(100*(re_epsZ),'b','Linewidth',2);axis tight;grid on; title('re');
subplot(12,5,52);
plot(100*(Ne_epsZ),'b','Linewidth',2);axis tight;grid on; title('New firms');
subplot(12,5,53);
plot(100*(mrs_epsZ),'b','Linewidth',2);axis tight;grid on; title('mrs');
subplot(12,5,54);
plot(100*(multR_epsZ),'b','Linewidth',2);axis tight;grid on; title('multR');
subplot(12,5,55);
plot(100*(mc_epsZ),'b','Linewidth',2);axis tight;grid on; title('mc');
*/


/*
*/
subplot(13,5,1);
plot((gc_epsG),'b','Linewidth',2);axis tight;grid on; title('gvt. cons');
subplot(13,5,2);
plot(100*(cmdata_epsG),'b','Linewidth',2);axis tight;grid on; title('Consumption');
subplot(13,5,3);
plot(100*(u_epsG*u_SS),'b','Linewidth',2);axis tight;grid on; title('Unemployment rate');
subplot(13,5,4);
plot(100*(ikdata_epsG),'b','Linewidth',2);axis tight;grid on; title('Investment physical capital');
subplot(13,5,5);
plot(100*(gdpIncomedata_epsG),'b','Linewidth',2);axis tight;grid on; title('GDP');
subplot(13,5,6);
plot(100*(wdata_epsG),'b','Linewidth',2);grid on;axis tight, title('Wage');
subplot(13,5,7);
plot(100*(N_epsG),'b','Linewidth',2);grid on;axis tight, title('Producers');
subplot(13,5,8);
plot(100*(iedata_epsG),'b','Linewidth',2);axis tight;grid on; title('Investment new products');
subplot(13,5,9);
plot(100*(markup_epsG),'b','Linewidth',2);axis tight;grid on; title('Markup');
subplot(13,5,10);
plot(100*(s_epsG),'b','Linewidth',2);axis tight;grid on; title('Job-finding prob.');
subplot(13,5,11);
plot(100*(thetaP_epsG),'b','Linewidth',2);axis tight;grid on; title('Labour mkt tight');
subplot(13,5,12);
plot(100*(ooption_epsG),'b','Linewidth',2);axis tight;grid on; title('Outside option');
subplot(13,5,13);
plot(100*(surplusW_epsG),'b','Linewidth',2);axis tight;grid on; title('surplusW');
subplot(13,5,14);
plot(100*(yfirm_epsG),'b','Linewidth',2);axis tight;grid on; title('Firm output');
subplot(13,5,15);
plot(100*(d_epsG),'b','Linewidth',2);axis tight;grid on; title('Profit');
subplot(13,5,16);
plot(100*(q_epsG),'b','Linewidth',2);axis tight;grid on; title('Prob. fill vacancy');
subplot(13,5,17);
plot(100*(zc_epsG),'b','Linewidth',2);axis tight;grid on; title('Prod. cut-off');
subplot(13,5,18);
plot(100*(vi_epsG),'b','Linewidth',2);axis tight;grid on; title('V incumbents');
subplot(13,5,19);
plot(100*(ve_epsG),'b','Linewidth',2);axis tight;grid on; title('V entrants');
subplot(13,5,20);
plot(100*(v_epsG),'b','Linewidth',2);axis tight;grid on; title('Vacancies');
subplot(13,5,21);
plot(100*(rho_epsG),'b','Linewidth',2);axis tight;grid on; title('Endo. separate');
subplot(13,5,22);
plot(100*(totsepagg_epsG),'b','Linewidth',2);axis tight;grid on; title('totsep agg');
subplot(13,5,23);
plot(100*(endosepAG_epsG),'b','Linewidth',2);axis tight;grid on; title('endosep agg');
subplot(13,5,24);
plot(100*(m_epsG),'b','Linewidth',2);axis tight;grid on; title('m');
subplot(13,5,25);
plot(100*(kq_epsG),'b','Linewidth',2);axis tight;grid on; title('fut. match val.');
subplot(13,5,26);
plot(100*(JC_epsG),'b','Linewidth',2);axis tight;grid on; title('JC');
subplot(13,5,27);
plot(100*(JD_epsG),'b','Linewidth',2);axis tight;grid on; title('JD');
subplot(13,5,28);
plot(100*(netJC_epsG),'b','Linewidth',2);axis tight;grid on; title('netJC');
subplot(13,5,29);
plot(100*(r_epsG),'b','Linewidth',2);axis tight;grid on; title('r');
subplot(13,5,30);
plot(100*(mpl_epsG),'b','Linewidth',2);axis tight;grid on; title('mpl');
subplot(13,5,31);
plot(100*(mpk_epsG),'b','Linewidth',2);axis tight;grid on; title('mpk');
subplot(13,5,32);
plot(100*(mc_epsG),'b','Linewidth',2);axis tight;grid on; title('MC');
subplot(13,5,33);
plot(100*(zav_epsG),'b','Linewidth',2);axis tight;grid on; title('z avg');
subplot(13,5,34);
plot(100*(surplusF_epsG),'b','Linewidth',2);axis tight;grid on; title('surplusF');
subplot(13,5,35);
plot(100*(phi_epsG),'b','Linewidth',2);axis tight;grid on; title('match val');
subplot(13,5,36);
plot(100*(wzcdata_epsG),'b','Linewidth',2);axis tight;grid on; title('wzcdata');
subplot(13,5,37);
plot(100*(rpD_epsG),'b','Linewidth',2);axis tight;grid on; title('rel. price');
subplot(13,5,38);
plot(100*(vfirm_epsG),'b','Linewidth',2);axis tight;grid on; title('vfirm');
subplot(13,5,39);
plot(100*(lfirm_epsG),'b','Linewidth',2);axis tight;grid on; title('lfirm');
subplot(13,5,40);
plot(100*(kfirm_epsG),'b','Linewidth',2);axis tight;grid on; title('kfirm');
subplot(13,5,41);
plot(100*(uc_epsG),'b','Linewidth',2);axis tight;grid on; title('uc');
subplot(13,5,42);
plot(100*(mplzc_epsG),'b','Linewidth',2);axis tight;grid on; title('mplzc');
subplot(13,5,43);
plot(100*(seprate_epsG),'b','Linewidth',2);axis tight;grid on; title('seprate');
subplot(13,5,44);
plot(100*(e_epsG),'b','Linewidth',2);axis tight;grid on; title('e');
subplot(13,5,45);
plot(100*(wageinc_epsG),'b','Linewidth',2);axis tight;grid on; title('wageinc');
subplot(13,5,46);
plot(100*(capinc_epsG),'b','Linewidth',2);axis tight;grid on; title('capinc');
subplot(13,5,47);
plot(100*(divinc_epsG),'b','Linewidth',2);axis tight;grid on; title('divinc');
subplot(13,5,48);
plot(100*(totinc_epsG),'b','Linewidth',2);axis tight;grid on; title('totinc');
subplot(13,5,49);
plot(100*(PRspend_epsG),'b','Linewidth',2);axis tight;grid on; title('PRspend');
subplot(13,5,50);
plot(100*(totspend_epsG),'b','Linewidth',2);axis tight;grid on; title('totspend');
subplot(13,5,51);
plot(100*(re_epsG),'b','Linewidth',2);axis tight;grid on; title('re');
subplot(13,5,52);
plot(100*(T_epsG),'b','Linewidth',2);axis tight;grid on; title('LS tax');
subplot(13,5,53);
plot(100*(mrs_epsG),'b','Linewidth',2);axis tight;grid on; title('mrs');
subplot(13,5,54);
plot(100*(multR_epsG),'b','Linewidth',2);axis tight;grid on; title('multR');
subplot(13,5,55);
plot(100*(mc_epsG),'b','Linewidth',2);axis tight;grid on; title('mc');
subplot(13,5,56);
plot(100*(tauK_epsG),'b','Linewidth',2);axis tight;grid on; title('tauK');
subplot(13,5,57);
plot(100*(tauW_epsG),'b','Linewidth',2);axis tight;grid on; title('tauW');
subplot(13,5,58);
plot(100*(Ne_epsG),'b','Linewidth',2);axis tight;grid on; title('New firms');
subplot(13,5,59);
plot(100*(rk_epsG),'b','Linewidth',2);axis tight;grid on; title('rk');
subplot(13,5,60);
plot(100*(y_epsG),'b','Linewidth',2);axis tight;grid on; title('Agg output');


/*
subplot(12,5,1);
plot((tauK_epsK),'b','Linewidth',2);axis tight;grid on; title('cap. inc. tax');
subplot(12,5,2);
plot(100*(cmdata_epsK),'b','Linewidth',2);axis tight;grid on; title('Consumption');
subplot(12,5,3);
plot(100*(u_epsK*u_SS),'b','Linewidth',2);axis tight;grid on; title('Unemployment rate');
subplot(12,5,4);
plot(100*(ikdata_epsK),'b','Linewidth',2);axis tight;grid on; title('Investment physical capital');
subplot(12,5,5);
plot(100*(gdpIncomedata_epsK),'b','Linewidth',2);axis tight;grid on; title('GDP');
subplot(12,5,6);
plot(100*(wdata_epsK),'b','Linewidth',2);grid on;axis tight, title('Wage');
subplot(12,5,7);
plot(100*(N_epsK),'b','Linewidth',2);grid on;axis tight, title('Producers');
subplot(12,5,8);
plot(100*(iedata_epsK),'b','Linewidth',2);axis tight;grid on; title('Investment new products');
subplot(12,5,9);
plot(100*(markup_epsK),'b','Linewidth',2);axis tight;grid on; title('Markup');
subplot(12,5,10);
plot(100*(s_epsK),'b','Linewidth',2);axis tight;grid on; title('Job-finding prob.');
subplot(12,5,11);
plot(100*(thetaP_epsK),'b','Linewidth',2);axis tight;grid on; title('Labour mkt tight');
subplot(12,5,12);
plot(100*(ooption_epsK),'b','Linewidth',2);axis tight;grid on; title('Outside option');
subplot(12,5,13);
plot(100*(surplusW_epsK),'b','Linewidth',2);axis tight;grid on; title('surplusW');
subplot(12,5,14);
plot(100*(yfirm_epsK),'b','Linewidth',2);axis tight;grid on; title('Firm output');
subplot(12,5,15);
plot(100*(d_epsK),'b','Linewidth',2);axis tight;grid on; title('Profit');
subplot(12,5,16);
plot(100*(q_epsK),'b','Linewidth',2);axis tight;grid on; title('Prob. fill vacancy');
subplot(12,5,17);
plot(100*(zc_epsK),'b','Linewidth',2);axis tight;grid on; title('Prod. cut-off');
subplot(12,5,18);
plot(100*(vi_epsK),'b','Linewidth',2);axis tight;grid on; title('V incumbents');
subplot(12,5,19);
plot(100*(ve_epsK),'b','Linewidth',2);axis tight;grid on; title('V entrants');
subplot(12,5,20);
plot(100*(v_epsK),'b','Linewidth',2);axis tight;grid on; title('Vacancies');
subplot(12,5,21);
plot(100*(rho_epsK),'b','Linewidth',2);axis tight;grid on; title('Endo. separate');
subplot(12,5,22);
plot(100*(totsepagg_epsK),'b','Linewidth',2);axis tight;grid on; title('totsep agg');
subplot(12,5,23);
plot(100*(endosepAG_epsK),'b','Linewidth',2);axis tight;grid on; title('endosep agg');
subplot(12,5,24);
plot(100*(m_epsK),'b','Linewidth',2);axis tight;grid on; title('m');
subplot(12,5,25);
plot(100*(kq_epsK),'b','Linewidth',2);axis tight;grid on; title('fut. match val.');
subplot(12,5,26);
plot(100*(JC_epsK),'b','Linewidth',2);axis tight;grid on; title('JC');
subplot(12,5,27);
plot(100*(JD_epsK),'b','Linewidth',2);axis tight;grid on; title('JD');
subplot(12,5,28);
plot(100*(netJC_epsK),'b','Linewidth',2);axis tight;grid on; title('netJC');
subplot(12,5,29);
plot(100*(r_epsK),'b','Linewidth',2);axis tight;grid on; title('r');
subplot(12,5,30);
plot(100*(mpl_epsK),'b','Linewidth',2);axis tight;grid on; title('mpl');
subplot(12,5,31);
plot(100*(mpk_epsK),'b','Linewidth',2);axis tight;grid on; title('mpk');
subplot(12,5,32);
plot(100*(mc_epsK),'b','Linewidth',2);axis tight;grid on; title('MC');
subplot(12,5,33);
plot(100*(zav_epsK),'b','Linewidth',2);axis tight;grid on; title('z avg');
subplot(12,5,34);
plot(100*(surplusF_epsK),'b','Linewidth',2);axis tight;grid on; title('surplusF');
subplot(12,5,35);
plot(100*(phi_epsK),'b','Linewidth',2);axis tight;grid on; title('match val');
subplot(12,5,36);
plot(100*(wzcdata_epsK),'b','Linewidth',2);axis tight;grid on; title('wzcdata');
subplot(12,5,37);
plot(100*(elasticity_epsK),'b','Linewidth',2);axis tight;grid on; title('elast');
subplot(12,5,38);
plot(100*(vfirm_epsK),'b','Linewidth',2);axis tight;grid on; title('vfirm');
subplot(12,5,39);
plot(100*(lfirm_epsK),'b','Linewidth',2);axis tight;grid on; title('lfirm');
subplot(12,5,40);
plot(100*(kfirm_epsK),'b','Linewidth',2);axis tight;grid on; title('kfirm');
subplot(12,5,41);
plot(100*(uc_epsK),'b','Linewidth',2);axis tight;grid on; title('uc');
subplot(12,5,42);
plot(100*(mplzc_epsK),'b','Linewidth',2);axis tight;grid on; title('mplzc');
subplot(12,5,43);
plot(100*(seprate_epsK),'b','Linewidth',2);axis tight;grid on; title('seprate');
subplot(12,5,44);
plot(100*(e_epsK),'b','Linewidth',2);axis tight;grid on; title('e');
subplot(12,5,45);
plot(100*(wageinc_epsK),'b','Linewidth',2);axis tight;grid on; title('wageinc');
subplot(12,5,46);
plot(100*(capinc_epsK),'b','Linewidth',2);axis tight;grid on; title('capinc');
subplot(12,5,47);
plot(100*(divinc_epsK),'b','Linewidth',2);axis tight;grid on; title('divinc');
subplot(12,5,48);
plot(100*(PRspend_epsK),'b','Linewidth',2);axis tight;grid on; title('PRspend');
subplot(12,5,49);
plot(100*(totinc_epsK),'b','Linewidth',2);axis tight;grid on; title('totinc');
subplot(12,5,50);
plot(100*(totspend_epsK),'b','Linewidth',2);axis tight;grid on; title('totspend');
subplot(12,5,51);
plot(100*(re_epsK),'b','Linewidth',2);axis tight;grid on; title('re');
subplot(12,5,52);
plot(100*(uc_epsK),'b','Linewidth',2);axis tight;grid on; title('uc');
subplot(12,5,53);
plot(100*(mrs_epsK),'b','Linewidth',2);axis tight;grid on; title('mrs');
subplot(12,5,54);
plot(100*(multR_epsK),'b','Linewidth',2);axis tight;grid on; title('multR');
subplot(12,5,55);
plot(100*(mc_epsK),'b','Linewidth',2);axis tight;grid on; title('mc');
*/


/*
subplot(12,5,1);
plot((tauW_epsW),'b','Linewidth',2);axis tight;grid on; title('lab. inc. tax');
subplot(12,5,2);
plot(100*(cmdata_epsW),'b','Linewidth',2);axis tight;grid on; title('Consumption');
subplot(12,5,3);
plot(100*(u_epsW*u_SS),'b','Linewidth',2);axis tight;grid on; title('Unemployment rate');
subplot(12,5,4);
plot(100*(ikdata_epsW),'b','Linewidth',2);axis tight;grid on; title('Investment physical capital');
subplot(12,5,5);
plot(100*(gdpIncomedata_epsW),'b','Linewidth',2);axis tight;grid on; title('GDP');
subplot(12,5,6);
plot(100*(wdata_epsW),'b','Linewidth',2);grid on;axis tight, title('Wage');
subplot(12,5,7);
plot(100*(N_epsW),'b','Linewidth',2);grid on;axis tight, title('Producers');
subplot(12,5,8);
plot(100*(iedata_epsW),'b','Linewidth',2);axis tight;grid on; title('Investment new products');
subplot(12,5,9);
plot(100*(markup_epsW),'b','Linewidth',2);axis tight;grid on; title('Markup');
subplot(12,5,10);
plot(100*(s_epsW),'b','Linewidth',2);axis tight;grid on; title('Job-finding prob.');
subplot(12,5,11);
plot(100*(thetaP_epsW),'b','Linewidth',2);axis tight;grid on; title('Labour mkt tight');
subplot(12,5,12);
plot(100*(ooption_epsW),'b','Linewidth',2);axis tight;grid on; title('Outside option');
subplot(12,5,13);
plot(100*(surplusW_epsW),'b','Linewidth',2);axis tight;grid on; title('surplusW');
subplot(12,5,14);
plot(100*(yfirm_epsW),'b','Linewidth',2);axis tight;grid on; title('Firm output');
subplot(12,5,15);
plot(100*(d_epsW),'b','Linewidth',2);axis tight;grid on; title('Profit');
subplot(12,5,16);
plot(100*(q_epsW),'b','Linewidth',2);axis tight;grid on; title('Prob. fill vacancy');
subplot(12,5,17);
plot(100*(zc_epsW),'b','Linewidth',2);axis tight;grid on; title('Prod. cut-off');
subplot(12,5,18);
plot(100*(vi_epsW),'b','Linewidth',2);axis tight;grid on; title('V incumbents');
subplot(12,5,19);
plot(100*(ve_epsW),'b','Linewidth',2);axis tight;grid on; title('V entrants');
subplot(12,5,20);
plot(100*(v_epsW),'b','Linewidth',2);axis tight;grid on; title('Vacancies');
subplot(12,5,21);
plot(100*(rho_epsW),'b','Linewidth',2);axis tight;grid on; title('Endo. separate');
subplot(12,5,22);
plot(100*(totsepagg_epsW),'b','Linewidth',2);axis tight;grid on; title('totsep agg');
subplot(12,5,23);
plot(100*(endosepAG_epsW),'b','Linewidth',2);axis tight;grid on; title('endosep agg');
subplot(12,5,24);
plot(100*(m_epsW),'b','Linewidth',2);axis tight;grid on; title('m');
subplot(12,5,25);
plot(100*(kq_epsW),'b','Linewidth',2);axis tight;grid on; title('fut. match val.');
subplot(12,5,26);
plot(100*(JC_epsW),'b','Linewidth',2);axis tight;grid on; title('JC');
subplot(12,5,27);
plot(100*(JD_epsW),'b','Linewidth',2);axis tight;grid on; title('JD');
subplot(12,5,28);
plot(100*(netJC_epsW),'b','Linewidth',2);axis tight;grid on; title('netJC');
subplot(12,5,29);
plot(100*(r_epsW),'b','Linewidth',2);axis tight;grid on; title('r');
subplot(12,5,30);
plot(100*(mpl_epsW),'b','Linewidth',2);axis tight;grid on; title('mpl');
subplot(12,5,31);
plot(100*(mpk_epsW),'b','Linewidth',2);axis tight;grid on; title('mpk');
subplot(12,5,32);
plot(100*(mc_epsW),'b','Linewidth',2);axis tight;grid on; title('MC');
subplot(12,5,33);
plot(100*(zav_epsW),'b','Linewidth',2);axis tight;grid on; title('z avg');
subplot(12,5,34);
plot(100*(surplusF_epsW),'b','Linewidth',2);axis tight;grid on; title('surplusF');
subplot(12,5,35);
plot(100*(phi_epsW),'b','Linewidth',2);axis tight;grid on; title('match val');
subplot(12,5,36);
plot(100*(wzcdata_epsW),'b','Linewidth',2);axis tight;grid on; title('wzcdata');
subplot(12,5,37);
plot(100*(elasticity_epsW),'b','Linewidth',2);axis tight;grid on; title('elast');
subplot(12,5,38);
plot(100*(vfirm_epsW),'b','Linewidth',2);axis tight;grid on; title('vfirm');
subplot(12,5,39);
plot(100*(lfirm_epsW),'b','Linewidth',2);axis tight;grid on; title('lfirm');
subplot(12,5,40);
plot(100*(kfirm_epsW),'b','Linewidth',2);axis tight;grid on; title('kfirm');
subplot(12,5,41);
plot(100*(uc_epsW),'b','Linewidth',2);axis tight;grid on; title('uc');
subplot(12,5,42);
plot(100*(mplzc_epsW),'b','Linewidth',2);axis tight;grid on; title('mplzc');
subplot(12,5,43);
plot(100*(seprate_epsW),'b','Linewidth',2);axis tight;grid on; title('seprate');
subplot(12,5,44);
plot(100*(e_epsW),'b','Linewidth',2);axis tight;grid on; title('e');
subplot(12,5,45);
plot(100*(wageinc_epsW),'b','Linewidth',2);axis tight;grid on; title('wageinc');
subplot(12,5,46);
plot(100*(capinc_epsW),'b','Linewidth',2);axis tight;grid on; title('capinc');
subplot(12,5,47);
plot(100*(divinc_epsW),'b','Linewidth',2);axis tight;grid on; title('divinc');
subplot(12,5,48);
plot(100*(PRspend_epsW),'b','Linewidth',2);axis tight;grid on; title('PRspend');
subplot(12,5,49);
plot(100*(totinc_epsW),'b','Linewidth',2);axis tight;grid on; title('totinc');
subplot(12,5,50);
plot(100*(totspend_epsW),'b','Linewidth',2);axis tight;grid on; title('totspend');
subplot(12,5,51);
plot(100*(re_epsW),'b','Linewidth',2);axis tight;grid on; title('re');
subplot(12,5,52);
plot(100*(uc_epsW),'b','Linewidth',2);axis tight;grid on; title('uc');
subplot(12,5,53);
plot(100*(mrs_epsW),'b','Linewidth',2);axis tight;grid on; title('mrs');
subplot(12,5,54);
plot(100*(multR_epsW),'b','Linewidth',2);axis tight;grid on; title('multR');
subplot(12,5,55);
plot(100*(mc_epsW),'b','Linewidth',2);axis tight;grid on; title('mc');
*/