function [residual, g1, g2] = cycle_irf_static(y, x, params)
%
% Status : Computes static model for Dynare
%
% Inputs : 
%   y         [M_.endo_nbr by 1] double    vector of endogenous variables in declaration order
%   x         [M_.exo_nbr by 1] double     vector of exogenous variables in declaration order
%   params    [M_.param_nbr by 1] double   vector of parameter values in declaration order
%
% Outputs:
%   residual  [M_.endo_nbr by 1] double    vector of residuals of the static model equations 
%                                          in order of declaration of the equations
%   g1        [M_.endo_nbr by M_.endo_nbr] double    Jacobian matrix of the static model equations;
%                                                     columns: variables in declaration order
%                                                     rows: equations in order of declaration
%   g2        [M_.endo_nbr by (M_.endo_nbr)^2] double   Hessian matrix of the static model equations;
%                                                       columns: variables in declaration order
%                                                       rows: equations in order of declaration
%
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

residual = zeros( 83, 1);

%
% Model equations
%

T25 = 1-exp(y(13));
T46 = params(2)*exp(y(40))/exp(y(40));
T79 = (1-params(6))/params(6)*exp(y(18))*1/(1-y(58));
T106 = exp(y(46))*exp(y(12))^params(20)*exp(y(5))^params(10);
T110 = exp(y(2))^(1-params(10));
T122 = exp(y(30));
T149 = exp(y(36))/exp(y(8));
T188 = exp(.5*(params(14)-exp(y(28)))/(exp(y(28))*params(14)*params(15)));
T208 = 1/T122*exp(y(21))/exp(y(28));
T226 = y(55)*exp(y(36))*exp(y(13))*exp(y(28))/T25;
T242 = 1-params(12)/2*y(25)^2;
T310 = exp(y(36))*exp(y(29))/exp(y(8));
T357 = params(20)*params(9)^2;
T367 = (-0.5)*params(11)^0.5*exp(params(20)*0.5*(2*params(8)+T357)/(1-2*params(10)+params(10)^2));
T382 = 0.7071067811865475/params(9)*(params(8)+T357+(-log(exp(y(7))))+params(10)*log(exp(y(7)))-params(10)*params(8))/((-1)+params(10));
T402 = exp(params(10)*params(8)*(-params(20))/((-1)+params(10))^2);
T404 = T367*(erf(T382)-erf(0.7071067811865475*(params(8)+T357+(-10000000000)+params(10)*10000000000-params(10)*params(8))/params(9)/((-1)+params(10))))*T402/params(11)^0.5;
T425 = exp(y(34))*(1-params(10))*exp(y(23))/exp(y(2));
T428 = exp(y(7))/exp(y(12));
T437 = exp(y(34))*params(10)*exp(y(23))/exp(y(5));
T567 = params(6)/(1-params(6));
T572 = exp(y(10))*y(55)*exp(y(40))*params(2)*(1-params(5))*(1-params(13))/exp(y(40));
T623 = (exp(y(35))+T149)*exp(y(29));
T770 = (-(exp(y(36))*exp(y(8))))/(exp(y(8))*exp(y(8)));
lhs =y(38);
rhs =log(exp(y(1)));
residual(1)= lhs-rhs;
lhs =y(39);
rhs =y(38)+y(39)*params(2);
residual(2)= lhs-rhs;
residual(3) = (-exp(y(36)))+exp(y(36))*(1-params(5))*T25+(1-params(5))*T25*exp(y(8))*exp(y(35));
residual(4) = (-params(17))/exp(y(8))+(1-params(5))*(1-params(13))*T46*(T25*exp(y(16))-exp(y(13))*y(55));
residual(5) = (-exp(y(42)))+exp(y(20))-params(17)/exp(y(8))-y(55);
residual(6) = (-exp(y(17)))+T79;
residual(7) = (-exp(y(20)))+exp(y(4))-params(6)*(exp(y(14))-exp(y(42)));
residual(8) = (-exp(y(34)))+T106*T110;
residual(9) = params(17)/exp(y(8))-exp(y(70));
residual(10) = (-exp(y(27)))+T122*exp(y(33))-exp(y(36))*exp(y(4))-exp(y(35))*params(17)-exp(y(15))*exp(y(37))-y(55)*exp(y(36))*exp(y(13))/T25;
residual(11) = (-exp(y(26)))+params(18)+y(56)+params(17)*(exp(y(35))+T149);
residual(12) = (-exp(y(33)))+exp(y(34))/exp(y(28));
residual(13) = (-T122)+exp(y(32))*exp(y(23));
residual(14) = (-exp(y(26)))+params(2)*(1-params(13))*(exp(y(27))+exp(y(26)));
residual(15) = (-exp(y(28)))+(1-params(13))*(exp(y(28))+exp(y(29)));
residual(16) = (-1)+T122*T188;
residual(17) = (-exp(y(32)))+exp(y(31))/(exp(y(31))-1);
residual(18) = (-exp(y(31)))+1+exp(y(28))*params(15);
residual(19) = (-exp(y(33)))+T208;
residual(20) = (-exp(y(21)))+exp(y(44))+exp(y(6))+params(17)*exp(y(3))+(params(18)+y(56))*exp(y(29))+T226+exp(y(57));
residual(21) = (-exp(y(5)))+exp(y(5))*(1-params(19))+exp(y(6))*T242;
residual(22) = (-exp(y(24)))+T46*(exp(y(22))*(1-y(59))+(1-params(19))*exp(y(24)));
residual(23) = (-1)+exp(y(24))*(T242-params(12)*y(25))+y(25)*exp(y(24))*T46*params(12);
residual(24) = 1-y(25)-1;
residual(25) = (-exp(y(40)))+params(2)*exp(y(40))*(1+exp(y(69)));
residual(26) = (1-params(5))*(1-params(13))*T46*(T25*exp(y(16))-exp(y(13))*y(55))+exp(y(14))-exp(y(16))-exp(y(4));
residual(27) = (-exp(y(18)))+(1-y(58))*exp(y(4))-exp(y(19))+exp(y(18))*T25*(1-params(5))*(1-params(13))*T46;
residual(28) = (-exp(y(19)))+params(23)+y(54)+exp(y(18))*T25*params(2)*(1-params(5))*(1-params(13))*exp(y(10));
residual(29) = (-exp(y(3)))+exp(y(35))*(exp(y(28))+exp(y(29)))+T310;
residual(30) = (-exp(y(36)))+exp(y(2))/exp(y(28));
residual(31) = (-exp(y(37)))+exp(y(5))/exp(y(28));
residual(32) = (-exp(y(9)))+params(16)*exp(y(3))^(1-params(7))*exp(y(11))^params(7);
residual(33) = 1-exp(y(11))-exp(y(2));
residual(34) = (-exp(y(10)))+exp(y(9))/exp(y(11));
residual(35) = (-exp(y(8)))+exp(y(9))/exp(y(3));
residual(36) = (-exp(y(41)))+T404/T25;
residual(37) = (-exp(y(12)))+exp(y(41))^((1-params(10))/params(20));
residual(38) = (-exp(y(13)))+0.5+0.5*erf(log(exp(y(7)))/(params(9)*1.414213562373095));
residual(39) = (-exp(y(14)))+T425;
residual(40) = (-exp(y(42)))+exp(y(14))*T428^params(21);
residual(41) = (-exp(y(15)))+T437;
residual(42) = y(55)+exp(y(16))+(-exp(y(17)));
residual(43) = exp(y(15))-exp(y(22));
residual(44) = exp(y(1))-exp(y(44))-params(23)*(1-exp(y(2)));
residual(45) = (-exp(y(40)))+exp(y(1))^(-params(1));
residual(46) = 1-exp(y(82));
residual(47) = (-y(46))+y(46)*params(3)-x(1);
residual(48) = (-y(54))+params(76);
residual(49) = (-y(55))+params(77);
residual(50) = (-y(56))+params(78);
residual(51) = (-y(57))+(1-params(24))*log(params(81))+y(57)*params(24)+x(2);
residual(52) = (-y(58))+params(31)+x(3);
residual(53) = (-y(59))+params(30)+x(4);
residual(54) = T25*(1-params(5))*params(13)+(1-params(5))*exp(y(13))+params(5)-exp(y(43));
residual(55) = (-exp(y(47)))+exp(y(4))*exp(y(2))+exp(y(5))*exp(y(22))+exp(y(27))*exp(y(28));
residual(56) = (params(18)+y(56))*exp(y(29))-exp(y(45));
residual(57) = (-exp(y(48)))+exp(y(47))/T122;
residual(58) = (-exp(y(49)))+exp(y(44))/T122;
residual(59) = (-exp(y(50)))+exp(y(6))/T122;
residual(60) = (-exp(y(52)))+exp(y(4))/T122;
residual(61) = (-exp(y(53)))+exp(y(1))/T122;
residual(62) = (-exp(y(51)))+exp(y(45))/T122;
residual(63) = (-exp(y(60)))+exp(y(3))/exp(y(11));
residual(64) = T567*(params(17)*exp(y(60))+T572)+y(54)+params(23)-exp(y(61));
residual(65) = (1-params(5))*exp(y(13))+params(5)-exp(y(62));
residual(66) = 1-exp(y(63))-(1-params(13))*(1-exp(y(62)));
residual(67) = (-exp(y(71)))+exp(y(2))*(1-params(5))*exp(y(13));
residual(68) = (-exp(y(64)))+exp(y(2))*exp(y(63))-exp(y(8))*params(5)*exp(y(2));
residual(69) = (-exp(y(65)))+exp(y(8))*exp(y(3))-exp(y(8))*params(5)*exp(y(2));
residual(70) = exp(y(65))-exp(y(66))-exp(y(64));
residual(71) = (-exp(y(68)))+T623;
residual(72) = exp(y(3))-exp(y(67))-exp(y(68));
residual(73) = (-exp(y(72)))+exp(y(26))/T122;
residual(74) = (-exp(y(73)))+exp(y(27))/T122;
residual(75) = (-exp(y(74)))+exp(y(20))/T122;
residual(76) = (-exp(y(75)))+exp(y(2))*(1-y(58))*exp(y(4));
residual(77) = (-exp(y(76)))+exp(y(5))*exp(y(22))*(1-y(59));
residual(78) = (-exp(y(77)))+exp(y(28))*(exp(y(27))+exp(y(26)));
residual(79) = (-exp(y(78)))+exp(y(26))*(exp(y(28))+exp(y(29)));
residual(80) = exp(y(2))*y(58)*exp(y(4))-exp(y(5))*exp(y(22))*y(59)-exp(y(57))+exp(y(77))+exp(y(76))+exp(y(75))-exp(y(79));
residual(81) = exp(y(6))+exp(y(78))+exp(y(44))-exp(y(80));
residual(82) = (-exp(y(81)))+(exp(y(27))+exp(y(26)))/exp(y(26));
residual(83) = exp(y(57))-exp(y(83))-exp(y(2))*y(58)*exp(y(4))-exp(y(5))*exp(y(22))*y(59);
if ~isreal(residual)
  residual = real(residual)+imag(residual).^2;
end
if nargout >= 2,
  g1 = zeros(83, 83);

  %
  % Jacobian matrix
  %

  g1(1,1)=(-1);
  g1(1,38)=1;
  g1(2,38)=(-1);
  g1(2,39)=1-params(2);
  g1(3,8)=(1-params(5))*T25*exp(y(8))*exp(y(35));
  g1(3,13)=exp(y(36))*(1-params(5))*(-exp(y(13)))+exp(y(35))*exp(y(8))*(1-params(5))*(-exp(y(13)));
  g1(3,35)=(1-params(5))*T25*exp(y(8))*exp(y(35));
  g1(3,36)=(-exp(y(36)))+exp(y(36))*(1-params(5))*T25;
  g1(4,8)=(-(exp(y(8))*(-params(17))))/(exp(y(8))*exp(y(8)));
  g1(4,13)=(1-params(5))*(1-params(13))*T46*(exp(y(16))*(-exp(y(13)))-exp(y(13))*y(55));
  g1(4,16)=(1-params(5))*(1-params(13))*T46*T25*exp(y(16));
  g1(4,55)=(1-params(5))*(1-params(13))*T46*(-exp(y(13)));
  g1(5,8)=(-((-(exp(y(8))*params(17)))/(exp(y(8))*exp(y(8)))));
  g1(5,20)=exp(y(20));
  g1(5,42)=(-exp(y(42)));
  g1(5,55)=(-1);
  g1(6,17)=(-exp(y(17)));
  g1(6,18)=T79;
  g1(6,58)=(1-params(6))/params(6)*exp(y(18))*1/((1-y(58))*(1-y(58)));
  g1(7,4)=exp(y(4));
  g1(7,14)=(-(params(6)*exp(y(14))));
  g1(7,20)=(-exp(y(20)));
  g1(7,42)=(-((-exp(y(42)))*params(6)));
  g1(8,2)=T106*exp(y(2))*getPowerDeriv(exp(y(2)),1-params(10),1);
  g1(8,5)=T110*exp(y(46))*exp(y(12))^params(20)*exp(y(5))*getPowerDeriv(exp(y(5)),params(10),1);
  g1(8,12)=T110*exp(y(5))^params(10)*exp(y(46))*exp(y(12))*getPowerDeriv(exp(y(12)),params(20),1);
  g1(8,34)=(-exp(y(34)));
  g1(8,46)=T106*T110;
  g1(9,8)=(-(exp(y(8))*params(17)))/(exp(y(8))*exp(y(8)));
  g1(9,70)=(-exp(y(70)));
  g1(10,4)=(-(exp(y(36))*exp(y(4))));
  g1(10,13)=(-((T25*y(55)*exp(y(36))*exp(y(13))-y(55)*exp(y(36))*exp(y(13))*(-exp(y(13))))/(T25*T25)));
  g1(10,15)=(-(exp(y(15))*exp(y(37))));
  g1(10,27)=(-exp(y(27)));
  g1(10,30)=T122*exp(y(33));
  g1(10,33)=T122*exp(y(33));
  g1(10,35)=(-(exp(y(35))*params(17)));
  g1(10,36)=(-(exp(y(36))*exp(y(4))))-y(55)*exp(y(36))*exp(y(13))/T25;
  g1(10,37)=(-(exp(y(15))*exp(y(37))));
  g1(10,55)=(-(exp(y(36))*exp(y(13))/T25));
  g1(11,8)=params(17)*T770;
  g1(11,26)=(-exp(y(26)));
  g1(11,35)=exp(y(35))*params(17);
  g1(11,36)=params(17)*T149;
  g1(11,56)=1;
  g1(12,28)=(-(exp(y(34))*exp(y(28))))/(exp(y(28))*exp(y(28)));
  g1(12,33)=(-exp(y(33)));
  g1(12,34)=exp(y(34))/exp(y(28));
  g1(13,23)=exp(y(32))*exp(y(23));
  g1(13,30)=(-T122);
  g1(13,32)=exp(y(32))*exp(y(23));
  g1(14,26)=(-exp(y(26)))+exp(y(26))*params(2)*(1-params(13));
  g1(14,27)=exp(y(27))*params(2)*(1-params(13));
  g1(15,28)=(-exp(y(28)))+(1-params(13))*exp(y(28));
  g1(15,29)=(1-params(13))*exp(y(29));
  g1(16,28)=T122*T188*(exp(y(28))*params(14)*params(15)*(-exp(y(28)))*.5-.5*(params(14)-exp(y(28)))*exp(y(28))*params(14)*params(15))/(exp(y(28))*params(14)*params(15)*exp(y(28))*params(14)*params(15));
  g1(16,30)=T122*T188;
  g1(17,31)=(exp(y(31))*(exp(y(31))-1)-exp(y(31))*exp(y(31)))/((exp(y(31))-1)*(exp(y(31))-1));
  g1(17,32)=(-exp(y(32)));
  g1(18,28)=exp(y(28))*params(15);
  g1(18,31)=(-exp(y(31)));
  g1(19,21)=T208;
  g1(19,28)=(-(exp(y(28))*1/T122*exp(y(21))))/(exp(y(28))*exp(y(28)));
  g1(19,30)=exp(y(21))*(-T122)/(T122*T122)/exp(y(28));
  g1(19,33)=(-exp(y(33)));
  g1(20,3)=params(17)*exp(y(3));
  g1(20,6)=exp(y(6));
  g1(20,13)=(T25*y(55)*exp(y(36))*exp(y(13))*exp(y(28))-y(55)*exp(y(36))*exp(y(13))*exp(y(28))*(-exp(y(13))))/(T25*T25);
  g1(20,21)=(-exp(y(21)));
  g1(20,28)=T226;
  g1(20,29)=(params(18)+y(56))*exp(y(29));
  g1(20,36)=T226;
  g1(20,44)=exp(y(44));
  g1(20,55)=exp(y(36))*exp(y(13))*exp(y(28))/T25;
  g1(20,56)=exp(y(29));
  g1(20,57)=exp(y(57));
  g1(21,5)=(-exp(y(5)))+exp(y(5))*(1-params(19));
  g1(21,6)=exp(y(6))*T242;
  g1(21,25)=exp(y(6))*(-(params(12)/2*2*y(25)));
  g1(22,22)=T46*exp(y(22))*(1-y(59));
  g1(22,24)=(-exp(y(24)))+T46*(1-params(19))*exp(y(24));
  g1(22,59)=T46*(-exp(y(22)));
  g1(23,24)=exp(y(24))*(T242-params(12)*y(25))+y(25)*exp(y(24))*T46*params(12);
  g1(23,25)=exp(y(24))*T46*params(12)+exp(y(24))*((-(params(12)/2*2*y(25)))-params(12));
  g1(24,25)=(-1);
  g1(25,40)=(-exp(y(40)))+params(2)*exp(y(40))*(1+exp(y(69)));
  g1(25,69)=params(2)*exp(y(40))*exp(y(69));
  g1(26,4)=(-exp(y(4)));
  g1(26,13)=(1-params(5))*(1-params(13))*T46*(exp(y(16))*(-exp(y(13)))-exp(y(13))*y(55));
  g1(26,14)=exp(y(14));
  g1(26,16)=(1-params(5))*(1-params(13))*T46*T25*exp(y(16))-exp(y(16));
  g1(26,55)=(1-params(5))*(1-params(13))*T46*(-exp(y(13)));
  g1(27,4)=(1-y(58))*exp(y(4));
  g1(27,13)=exp(y(18))*(1-params(5))*(1-params(13))*T46*(-exp(y(13)));
  g1(27,18)=(-exp(y(18)))+exp(y(18))*T25*(1-params(5))*(1-params(13))*T46;
  g1(27,19)=(-exp(y(19)));
  g1(27,58)=(-exp(y(4)));
  g1(28,10)=exp(y(18))*T25*params(2)*(1-params(5))*(1-params(13))*exp(y(10));
  g1(28,13)=exp(y(18))*params(2)*(1-params(5))*(1-params(13))*exp(y(10))*(-exp(y(13)));
  g1(28,18)=exp(y(18))*T25*params(2)*(1-params(5))*(1-params(13))*exp(y(10));
  g1(28,19)=(-exp(y(19)));
  g1(28,54)=1;
  g1(29,3)=(-exp(y(3)));
  g1(29,8)=(-(exp(y(8))*exp(y(36))*exp(y(29))))/(exp(y(8))*exp(y(8)));
  g1(29,28)=exp(y(35))*exp(y(28));
  g1(29,29)=T310+exp(y(35))*exp(y(29));
  g1(29,35)=exp(y(35))*(exp(y(28))+exp(y(29)));
  g1(29,36)=T310;
  g1(30,2)=exp(y(2))/exp(y(28));
  g1(30,28)=(-(exp(y(2))*exp(y(28))))/(exp(y(28))*exp(y(28)));
  g1(30,36)=(-exp(y(36)));
  g1(31,5)=exp(y(5))/exp(y(28));
  g1(31,28)=(-(exp(y(5))*exp(y(28))))/(exp(y(28))*exp(y(28)));
  g1(31,37)=(-exp(y(37)));
  g1(32,3)=exp(y(11))^params(7)*params(16)*exp(y(3))*getPowerDeriv(exp(y(3)),1-params(7),1);
  g1(32,9)=(-exp(y(9)));
  g1(32,11)=params(16)*exp(y(3))^(1-params(7))*exp(y(11))*getPowerDeriv(exp(y(11)),params(7),1);
  g1(33,2)=(-exp(y(2)));
  g1(33,11)=(-exp(y(11)));
  g1(34,9)=exp(y(9))/exp(y(11));
  g1(34,10)=(-exp(y(10)));
  g1(34,11)=(-(exp(y(9))*exp(y(11))))/(exp(y(11))*exp(y(11)));
  g1(35,3)=(-(exp(y(3))*exp(y(9))))/(exp(y(3))*exp(y(3)));
  g1(35,8)=(-exp(y(8)));
  g1(35,9)=exp(y(9))/exp(y(3));
  g1(36,7)=T402*T367*0.7071067811865475/params(9)*((-1)+params(10))/((-1)+params(10))*2/(exp(T382^2)*1.772453850905516)/params(11)^0.5/T25;
  g1(36,13)=(-(T404*(-exp(y(13)))))/(T25*T25);
  g1(36,41)=(-exp(y(41)));
  g1(37,12)=(-exp(y(12)));
  g1(37,41)=exp(y(41))*getPowerDeriv(exp(y(41)),(1-params(10))/params(20),1);
  g1(38,7)=0.5*1/(params(9)*1.414213562373095)*2/(1.772453850905516*exp((log(exp(y(7)))/(params(9)*1.414213562373095))^2));
  g1(38,13)=(-exp(y(13)));
  g1(39,2)=(-(exp(y(2))*exp(y(34))*(1-params(10))*exp(y(23))))/(exp(y(2))*exp(y(2)));
  g1(39,14)=(-exp(y(14)));
  g1(39,23)=T425;
  g1(39,34)=T425;
  g1(40,7)=exp(y(14))*T428*getPowerDeriv(T428,params(21),1);
  g1(40,12)=exp(y(14))*getPowerDeriv(T428,params(21),1)*(-(exp(y(12))*exp(y(7))))/(exp(y(12))*exp(y(12)));
  g1(40,14)=exp(y(14))*T428^params(21);
  g1(40,42)=(-exp(y(42)));
  g1(41,5)=(-(exp(y(5))*exp(y(34))*params(10)*exp(y(23))))/(exp(y(5))*exp(y(5)));
  g1(41,15)=(-exp(y(15)));
  g1(41,23)=T437;
  g1(41,34)=T437;
  g1(42,16)=exp(y(16));
  g1(42,17)=(-exp(y(17)));
  g1(42,55)=1;
  g1(43,15)=exp(y(15));
  g1(43,22)=(-exp(y(22)));
  g1(44,1)=exp(y(1));
  g1(44,2)=(-(params(23)*(-exp(y(2)))));
  g1(44,44)=(-exp(y(44)));
  g1(45,1)=exp(y(1))*getPowerDeriv(exp(y(1)),(-params(1)),1);
  g1(45,40)=(-exp(y(40)));
  g1(46,82)=(-exp(y(82)));
  g1(47,46)=(-1)+params(3);
  g1(48,54)=(-1);
  g1(49,55)=(-1);
  g1(50,56)=(-1);
  g1(51,57)=(-1)+params(24);
  g1(52,58)=(-1);
  g1(53,59)=(-1);
  g1(54,13)=(1-params(5))*exp(y(13))+(-exp(y(13)))*(1-params(5))*params(13);
  g1(54,43)=(-exp(y(43)));
  g1(55,2)=exp(y(4))*exp(y(2));
  g1(55,4)=exp(y(4))*exp(y(2));
  g1(55,5)=exp(y(5))*exp(y(22));
  g1(55,22)=exp(y(5))*exp(y(22));
  g1(55,27)=exp(y(27))*exp(y(28));
  g1(55,28)=exp(y(27))*exp(y(28));
  g1(55,47)=(-exp(y(47)));
  g1(56,29)=(params(18)+y(56))*exp(y(29));
  g1(56,45)=(-exp(y(45)));
  g1(56,56)=exp(y(29));
  g1(57,30)=(-(T122*exp(y(47))))/(T122*T122);
  g1(57,47)=exp(y(47))/T122;
  g1(57,48)=(-exp(y(48)));
  g1(58,30)=(-(T122*exp(y(44))))/(T122*T122);
  g1(58,44)=exp(y(44))/T122;
  g1(58,49)=(-exp(y(49)));
  g1(59,6)=exp(y(6))/T122;
  g1(59,30)=(-(T122*exp(y(6))))/(T122*T122);
  g1(59,50)=(-exp(y(50)));
  g1(60,4)=exp(y(4))/T122;
  g1(60,30)=(-(exp(y(4))*T122))/(T122*T122);
  g1(60,52)=(-exp(y(52)));
  g1(61,1)=exp(y(1))/T122;
  g1(61,30)=(-(exp(y(1))*T122))/(T122*T122);
  g1(61,53)=(-exp(y(53)));
  g1(62,30)=(-(T122*exp(y(45))))/(T122*T122);
  g1(62,45)=exp(y(45))/T122;
  g1(62,51)=(-exp(y(51)));
  g1(63,3)=exp(y(3))/exp(y(11));
  g1(63,11)=(-(exp(y(3))*exp(y(11))))/(exp(y(11))*exp(y(11)));
  g1(63,60)=(-exp(y(60)));
  g1(64,10)=T567*T572;
  g1(64,54)=1;
  g1(64,55)=T567*exp(y(10))*exp(y(40))*params(2)*(1-params(5))*(1-params(13))/exp(y(40));
  g1(64,60)=T567*params(17)*exp(y(60));
  g1(64,61)=(-exp(y(61)));
  g1(65,13)=(1-params(5))*exp(y(13));
  g1(65,62)=(-exp(y(62)));
  g1(66,62)=(-((1-params(13))*(-exp(y(62)))));
  g1(66,63)=(-exp(y(63)));
  g1(67,2)=exp(y(2))*(1-params(5))*exp(y(13));
  g1(67,13)=exp(y(2))*(1-params(5))*exp(y(13));
  g1(67,71)=(-exp(y(71)));
  g1(68,2)=exp(y(2))*exp(y(63))-exp(y(8))*params(5)*exp(y(2));
  g1(68,8)=(-(exp(y(8))*params(5)*exp(y(2))));
  g1(68,63)=exp(y(2))*exp(y(63));
  g1(68,64)=(-exp(y(64)));
  g1(69,2)=(-(exp(y(8))*params(5)*exp(y(2))));
  g1(69,3)=exp(y(8))*exp(y(3));
  g1(69,8)=exp(y(8))*exp(y(3))-exp(y(8))*params(5)*exp(y(2));
  g1(69,65)=(-exp(y(65)));
  g1(70,64)=(-exp(y(64)));
  g1(70,65)=exp(y(65));
  g1(70,66)=(-exp(y(66)));
  g1(71,8)=exp(y(29))*T770;
  g1(71,29)=T623;
  g1(71,35)=exp(y(35))*exp(y(29));
  g1(71,36)=T149*exp(y(29));
  g1(71,68)=(-exp(y(68)));
  g1(72,3)=exp(y(3));
  g1(72,67)=(-exp(y(67)));
  g1(72,68)=(-exp(y(68)));
  g1(73,26)=exp(y(26))/T122;
  g1(73,30)=(-(T122*exp(y(26))))/(T122*T122);
  g1(73,72)=(-exp(y(72)));
  g1(74,27)=exp(y(27))/T122;
  g1(74,30)=(-(exp(y(27))*T122))/(T122*T122);
  g1(74,73)=(-exp(y(73)));
  g1(75,20)=exp(y(20))/T122;
  g1(75,30)=(-(exp(y(20))*T122))/(T122*T122);
  g1(75,74)=(-exp(y(74)));
  g1(76,2)=exp(y(2))*(1-y(58))*exp(y(4));
  g1(76,4)=exp(y(2))*(1-y(58))*exp(y(4));
  g1(76,58)=exp(y(2))*(-exp(y(4)));
  g1(76,75)=(-exp(y(75)));
  g1(77,5)=exp(y(5))*exp(y(22))*(1-y(59));
  g1(77,22)=exp(y(5))*exp(y(22))*(1-y(59));
  g1(77,59)=exp(y(5))*(-exp(y(22)));
  g1(77,76)=(-exp(y(76)));
  g1(78,26)=exp(y(26))*exp(y(28));
  g1(78,27)=exp(y(27))*exp(y(28));
  g1(78,28)=exp(y(28))*(exp(y(27))+exp(y(26)));
  g1(78,77)=(-exp(y(77)));
  g1(79,26)=exp(y(26))*(exp(y(28))+exp(y(29)));
  g1(79,28)=exp(y(26))*exp(y(28));
  g1(79,29)=exp(y(26))*exp(y(29));
  g1(79,78)=(-exp(y(78)));
  g1(80,2)=exp(y(2))*y(58)*exp(y(4));
  g1(80,4)=exp(y(2))*y(58)*exp(y(4));
  g1(80,5)=(-(exp(y(5))*exp(y(22))*y(59)));
  g1(80,22)=(-(exp(y(5))*exp(y(22))*y(59)));
  g1(80,57)=(-exp(y(57)));
  g1(80,58)=exp(y(4))*exp(y(2));
  g1(80,59)=(-(exp(y(5))*exp(y(22))));
  g1(80,75)=exp(y(75));
  g1(80,76)=exp(y(76));
  g1(80,77)=exp(y(77));
  g1(80,79)=(-exp(y(79)));
  g1(81,6)=exp(y(6));
  g1(81,44)=exp(y(44));
  g1(81,78)=exp(y(78));
  g1(81,80)=(-exp(y(80)));
  g1(82,26)=(exp(y(26))*exp(y(26))-exp(y(26))*(exp(y(27))+exp(y(26))))/(exp(y(26))*exp(y(26)));
  g1(82,27)=exp(y(27))/exp(y(26));
  g1(82,81)=(-exp(y(81)));
  g1(83,2)=(-(exp(y(2))*y(58)*exp(y(4))));
  g1(83,4)=(-(exp(y(2))*y(58)*exp(y(4))));
  g1(83,5)=(-(exp(y(5))*exp(y(22))*y(59)));
  g1(83,22)=(-(exp(y(5))*exp(y(22))*y(59)));
  g1(83,57)=exp(y(57));
  g1(83,58)=(-(exp(y(4))*exp(y(2))));
  g1(83,59)=(-(exp(y(5))*exp(y(22))));
  g1(83,83)=(-exp(y(83)));
  if ~isreal(g1)
    g1 = real(g1)+2*imag(g1);
  end
end
if nargout >= 3,
  %
  % Hessian matrix
  %

  g2 = sparse([],[],[],83,6889);
end
end
