clear;
load calibration; load guess; load options; load policyTargets; load reforms




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if (ubI==1);     rrRateP       = rrRateFlex;       end
if (fcI==1);     fcRate        = fcRateFlex;       end
if (pmrI==1);    feregrateP    = feregtargetFlex;  end
% save policyRates rrRateP fcRate feregrateP
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



x0 = [c0,k0,w0,zc0,q0,l0,N0];
options = optimset('Display','off','MaxIter', 5000,'MaxFunEvals',5000,'TolFun', 1.0000e-14,'TolX', 1.0000e-14);
[steadySol,fval] = fsolve(@(x) newsteady_solver(x),x0,options);


c_SS             = steadySol(1);
k_SS             = steadySol(2);
w_SS             = steadySol(3);
zc_SS            = steadySol(4);
q_SS             = steadySol(5);
l_SS             = steadySol(6);
N_SS             = steadySol(7);


if max(abs(fval)) > 1e-10
    display('Inaccurate new steady state')
    disp([' fval = ' num2str(max(abs(fval)),'%.4f') ]);
    keyboard
end

if min(steadySol) < 0
    display('Zero or negative new steady-state values')    
    keyboard
end



elasticity_SS       =(1 + sigmaMuP*N_SS);
markup_SS           = elasticity_SS/(elasticity_SS - 1);
rpD_SS              =(exp(-0.5*(NbarP-N_SS)/(sigmaMuP*NbarP*N_SS)));
ubP                 = rrRateP*w_SS/rpD_SS; 

if (fcI==0);
    load steadyInitial; fcP = fc_SSinit;
else
    fcP             = fcRate*w_SS;
end

z_SS                = 1;
tauW_SS             = 0.20;
tauK_SS             = 0.10;
mc_SS               = rpD_SS/markup_SS;
Ne_SS               = (deltafP/(1-deltafP))*N_SS;
rho_SS              = cdf('lognormal', zc_SS , meanziP , stdziP);
zavInt_SS           = (-1/2*piP^(1/2)*exp(1/2*(2*meanziP+stdziP^2*shapeP)*shapeP/(1-2*alphaP+alphaP^2))*(erf(1/2*2^(1/2)/stdziP*(-log(zc_SS)+log(zc_SS)*alphaP+stdziP^2*shapeP+meanziP-meanziP*alphaP)/(-1+alphaP))-erf(1/2*2^(1/2)*(-10000000000+10000000000*alphaP+stdziP^2*shapeP+meanziP-meanziP*alphaP)/stdziP/(-1+alphaP)))*exp(-shapeP*meanziP*alphaP/(-1+alphaP)^2)/piP^(1/2))/(1-rho_SS);
zav_SS              = zavInt_SS^(1/exponenpfP);
u_SS                = 1 - l_SS;
m_SS                = (l_SS - (1-lambdaP)*(1-deltafP)*(1-rho_SS)*l_SS)/((1-lambdaP)*(1-deltafP)*(1-rho_SS));
v_SS                = m_SS/q_SS;
s_SS                = m_SS/u_SS;
yn_SS               = z_SS*(zav_SS^shapeP)*(k_SS^alphaP)*(l_SS^(1-alphaP));
mpl_SS              = (1 - alphaP)*mc_SS*yn_SS/l_SS;
mplzc_SS            = mpl_SS*((zc_SS/zav_SS)^exponenpfP);
wzc_SS              = w_SS - etaP*(mpl_SS - mplzc_SS); 
% phi_SS              = mpl_SS + vcP/q_SS - (etaP*(mpl_SS + vcP*(s_SS/q_SS)) + (1-etaP)*(ubP + hpP) + (etaP*(1 - (1-lambdaP)*(1-deltafP)*(1-s_SS)*betaP)*fcP));
phi_SS               = mpl_SS + vcP/q_SS - w_SS;
mpk_SS              = alphaP*mc_SS*yn_SS/k_SS;
ik_SS               = deltakP*k_SS;                     
kfirm_SS            = k_SS/N_SS;
lfirm_SS            = l_SS/N_SS;
cm_SS               = c_SS - hpP*(1-l_SS);

load steadyInitial yn_SSinit
fetechP              = fetechtarget*yn_SSinit;
fr_SS                = feregrateP*yn_SS;
if (pmrI==0); load steadyInitial; fr_SS = fr_SSinit; end

fe_SS                = fetechP + fr_SS;




% y_SS                 = Ne_SS*fe_SS + cm_SS + ik_SS + vcP*v_SS + rho_SS*l_SS*fcP/(1-rho_SS);
% y_SS                 = Ne_SS*fe_SS + cm_SS + ik_SS + vcP*v_SS + rho_SS*l_SS*fcP/(1-rho_SS) + g_SS;
% yfirm_SS             = (1/rpD_SS)*y_SS/N_SS;

yfirm_SS             = yn_SS/N_SS;
y_SS                 = rpD_SS*yfirm_SS*N_SS;

vfirm_SS             = (v_SS - Ne_SS*lfirm_SS/q_SS)/(N_SS + Ne_SS);
d_SS                 = rpD_SS*yfirm_SS - mpk_SS*kfirm_SS - vcP*vfirm_SS - rho_SS*lfirm_SS*fcP/(1-rho_SS)  - lfirm_SS*w_SS;
e_SS                 = fe_SS + vcP*(lfirm_SS/q_SS + vfirm_SS);
firing_SS            = etaP*(1 - (1-lambdaP)*(1-deltafP)*(1-s_SS)*betaP)*fcP;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
surplusF_SS          = phi_SS + fcP;
% surplusW_SS          = (etaP/(1-etaP))*surplusF_SS;
surplusW_SS          = (etaP/(1-etaP))*surplusF_SS*(1-tauW_SS);
oo_SS                = hpP + ubP + s_SS*(1-lambdaP)*(1-deltafP)*betaP*(1-rho_SS)*surplusW_SS;
ub_SS                = ubP;
fc_SS                = fcP;
rk_SS                = mpk_SS;
multR_SS             = 1;
adjI_SS              = 0;
uc_SS                = c_SS^-gammaP;

rhotot_SS            = (1 - (1-lambdaP)*(1-deltafP)*(1-rho_SS))/((1-lambdaP)*(1-deltafP)*(1-rho_SS));
itot_SS              = ik_SS + Ne_SS*e_SS;
gdpIncome_SS         = w_SS*l_SS + rk_SS*k_SS + N_SS*d_SS;
gdpExpen_SS          = cm_SS + ik_SS;
phizc_SS             = mplzc_SS - wzc_SS + (1-lambdaP)*(1-deltafP)*(betaP)*( (1-rho_SS)*phi_SS - rho_SS*fc_SS ); 
surplusWzc_SS        = wzc_SS - oo_SS + (1-lambdaP)*(1-deltafP)*(betaP)*(1-rho_SS)*surplusW_SS; 
surplusFzc_SS        = phizc_SS + fc_SS;
% surplusFzc_SS        = ( (1 - etaP)/etaP)*surplusWzc_SS;
% phizc_SS             =  surplusFzc_SS - fc_SS;

%% Additional equations

r_SS                 = (1 - betaP)/betaP;
gc_SS                 = omegaG*gdpIncome_SS;
% D_SS                 = gc_SS + ub_SS*u_SS - tauW_SS*w_SS*l_SS;

% Additional variables
wdata_SS             = w_SS/rpD_SS;
thetaP_SS            = v_SS/u_SS; % labour market tightness
ooption_SS           = hpP + ub_SS + (etaP/(1 - etaP))*(vcP*thetaP_SS + s_SS*((1-lambdaP)*(1-deltafP)*betaP*fc_SS)); % worker outside option
endosepAG_SS         =  (1 - lambdaP)*rho_SS*l_SS; % aggregate endogenous separation
exosepAG_SS          = lambdaP*l_SS; % aggregate exogenous separation 
endosepfirm_SS       =  (1 - lambdaP)*rho_SS*lfirm_SS; % firm endogenous separation
exosepfirm_SS        = lambdaP*lfirm_SS; % aggregate exogenous separation 
newhiresfirm_SS      = q_SS*vfirm_SS; % new hires at firm level 
newhiresAG_SS        = q_SS*v_SS; % new hires at aggregate level
totsepfirm_SS        = lambdaP + (1-lambdaP)*rho_SS; % total fraction of jobs destroyed within the firm 
totsepagg_SS         = 1 - ((1 - totsepfirm_SS)*(1 - deltafP)); % Economy wide total separation rate, reflecting both within firm and across firm job separation (as in CM thesis)
JD_SS                = totsepagg_SS*l_SS - lambdaP*l_SS*q_SS; % Gross job destruction
JC_SS                = v_SS*q_SS - lambdaP*l_SS*q_SS; % Gross job creation
ve_SS                = (lfirm_SS/q_SS + vfirm_SS)*Ne_SS;
vi_SS                = v_SS - ve_SS;

% JD1_SS               = totsepagg_SS*l_SS;
% JD2_SS               = lambdaP*l_SS*q_SS;
% JC1_SS               = v_SS*q_SS;
% JC2_SS               = lambdaP*l_SS*q_SS;
netJC_SS             = JC_SS - JD_SS;
Util_SS                = log(c_SS);
Welf_SS                = (1/(1-betaP))*Util_SS;
edata_SS             = e_SS/rpD_SS;
ddata_SS             = d_SS/rpD_SS;
% re_SS                = (edata_SS + ddata_SS)/edata_SS;
re_SS                = (e_SS + d_SS)/e_SS;
% wageinc_SS           = w_SS*l_SS;
wageinc_SS           = (1-tauW_SS)*w_SS*l_SS;
% capinc_SS            = rk_SS*k_SS;
capinc_SS            = (1-tauK_SS)*rk_SS*k_SS;
divinc_SS            = (d_SS + e_SS)*N_SS;
PRspend_SS           = (N_SS + Ne_SS)*e_SS;
totinc_SS            = wageinc_SS + capinc_SS + divinc_SS + (tauW_SS*w_SS*l_SS - tauK_SS*rk_SS*k_SS - gc_SS);
totspend_SS          = cm_SS + PRspend_SS + ik_SS;
mrs_SS               = 1;
T_SS                 = gc_SS - tauW_SS*w_SS*l_SS - tauK_SS*rk_SS*k_SS;
kq_SS                = vcP/q_SS;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
             
save steady      z_SS c_SS l_SS q_SS m_SS s_SS u_SS v_SS w_SS mc_SS rho_SS zav_SS zc_SS wzc_SS phi_SS ...
                 surplusF_SS surplusW_SS y_SS ub_SS fc_SS fr_SS ik_SS k_SS mpl_SS mpk_SS rk_SS oo_SS  multR_SS adjI_SS ub_SS fc_SS ubP...
                 e_SS d_SS N_SS Ne_SS rpD_SS elasticity_SS markup_SS yfirm_SS yn_SS...
                 vfirm_SS lfirm_SS kfirm_SS mplzc_SS wzc_SS phizc_SS surplusFzc_SS surplusWzc_SS uc_SS...
                 cm_SS itot_SS gdpIncome_SS gdpExpen_SS zavInt_SS gc_SS r_SS thetaP_SS ooption_SS firing_SS endosepAG_SS exosepAG_SS endosepfirm_SS exosepfirm_SS... 
                 newhiresfirm_SS newhiresAG_SS totsepfirm_SS totsepagg_SS JD_SS JC_SS netJC_SS fe_SS Util_SS Welf_SS ve_SS vi_SS re_SS ...
                 wageinc_SS capinc_SS divinc_SS PRspend_SS totinc_SS totspend_SS mrs_SS T_SS kq_SS;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% save final values
 clear all; load steady;
 variables_list = cellstr(who);
 for i_index = 1: length(variables_list)
     varname = genvarname([variables_list{i_index},'fin']);
     eval([varname '= ',[variables_list{i_index}],';']);               
 end

savefile = 'steadyFinal';
save(savefile, '*_SSfin')
